//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert           = "DSS3";
extern bool   EcnBroker             = true;
extern string SymbolsPrefix         = "";
extern string SymbolsSuffix         = "";
extern bool   UseAutoMagic          = true;
extern int    ManualMagic           = 82828282;  
extern double lStopLoss             = 50;
extern double sStopLoss             = 50;
extern double lTakeProfit           = 70;
extern double sTakeProfit           = 70;
extern double lTrailingStop         = 12;
extern double sTrailingStop         = 12;
extern int    Slippage              = 4;
extern double Lots                  = 0.01;
extern double MaximumRisk           = 0;
extern double DecreaseFactor        = 3;

extern int    Stochastic.Period1    = 34;
extern int    Ema.Smoothing.Period1 = 5;
extern double Up.Level1             = 80;
extern double Dn.Level1             = 20;
extern int    bar1                  = 1;
extern int    Stochastic.Period2    = 55;
extern int    Ema.Smoothing.Period2 = 8;
extern double Up.Level2             = 80;
extern double Dn.Level2             = 20;
extern int    bar2                  = 1;
extern int    Stochastic.Period3    = 100;
extern int    Ema.Smoothing.Period3 = 8;
extern double Up.Level3             = 80;
extern double Dn.Level3             = 20;
extern int    bar3                  = 1;


extern bool   UseHourTrade          = false;
extern int    FromHourTrade         = 8;
extern int    ToHourTrade           = 19;

extern color  clOpenBuy             = Blue;
extern color  clOpenSell            = Red;

//
//
//
//
//

double pipMultiplier = 1;
string s_symbol;
int    MAGIC;

//
//
//
//
//

int init() 
{
  s_symbol = Symbol();
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic;  
              
return(0);
}

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (Digits == 3 || Digits == 5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;  
   
   //
   //
   //
   //
   //
   
   if(Bars < 100) { Print("bars less than 100"); return(0); }
   
   //
   //
   //
   //
   //
   
   if (UseHourTrade)
   {
     if(!(Hour() >= FromHourTrade && Hour() <= ToHourTrade)) { Comment("Non-Trading Hours!");  return(0);  }
   }
   
   //
   //
   //
   //
   //
   
   if(lStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(lTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   if(sStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(sTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   
   //
   //
   //
   //
   //
   
   
   double dss1now = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period1,Ema.Smoothing.Period1,0,bar1);
   double dss1pre = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period1,Ema.Smoothing.Period1,0,bar1+1);
   double dss2now = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period2,Ema.Smoothing.Period2,0,bar2);
   double dss2pre = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period2,Ema.Smoothing.Period2,0,bar2+1);
   double dss3now = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period3,Ema.Smoothing.Period3,0,bar3);
   double dss3pre = iCustom(NULL,0,"Double smoothed stochastic 2",Stochastic.Period3,Ema.Smoothing.Period3,0,bar3+1);
   
   //
   //
   //
   //
   //
   
   if (!ExistPositions())
   {
      
      if (dss1now > dss1pre && dss1now < Dn.Level1 && dss2now < Dn.Level2 && dss3now < Dn.Level3) 
      {
         OpenBuy();
         return(0);
      }

      if (dss1now < dss1pre && dss1now > Up.Level1 && dss2now > Up.Level2 && dss3now > Up.Level3) 
      {
         OpenSell();
         return(0);
      }
      
   
   }
   
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   
   return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}

//
//
//
//
//

void TrailingPositionsBuy(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice() >       trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss()   < Bid - trailingStop * Point * pipMultiplier) 
                     ModifyStopLoss(Bid -       trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() > Ask + trailingStop * Point * pipMultiplier || OrderStopLoss() == 0)  
                     ModifyStopLoss(Ask   +   trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = GetStopLossBuy(); 
   double lbTake = GetTakeProfitBuy();
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 

   double lsStop = GetStopLossSell(); 
   double lsTake = GetTakeProfitSell();
  
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket   = OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket  >= 0)
         int sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
          }
    }		       
} 

//
//
//
//
//

double GetStopLossBuy()    { 	return(Bid - lStopLoss   * Point * pipMultiplier); } 
double GetStopLossSell()   { 	return(Ask + sStopLoss   * Point * pipMultiplier); } 
double GetTakeProfitBuy()  { 	return(Ask + lTakeProfit * Point * pipMultiplier); } 
double GetTakeProfitSell() { 	return(Bid - sTakeProfit * Point * pipMultiplier); } 

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract = MarketInfo(Symbol(),MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage() <= 0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!=Symbol() || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
      
   if(losses > 1) lot = NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0) * lot_step;
   if(lot < lot_min) lot = lot_min;
   if(lot > lot_max) lot = lot_max;
   
   //
   //
   //
   //
   //
   
   return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(91922921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(91922922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(91922931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(91922932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(91922941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(91922942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(91922951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(91922961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(91922962);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(91922963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(91922964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(91922965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(91922966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(91922967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(91922971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(91922972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(91922973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(91922981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(91922982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(91922983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(91922991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(91922992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(91922993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(91922994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(91922295);
   
   //
   //
   //    some other symbol, use manual magic number
   //
   //
   
   return(ManualMagic);
}



